#include "ModuleHTTP.h"
#include <httplib.h>
#include <iostream>

using namespace httplib;

namespace mdd{

    void ModuleHTTP::updateLayout(){
        Client cli(_id, _port);

        std::string body;
        auto res = cli.Get("/inputs",
                           [&](const char *data, size_t data_length) {
                               body.append(data, data_length);
                               return true;
                           });
        //assert(res->body.empty());
        std::cout<<body<<std::endl;
        json inputs = json::parse(body);

        if(getInputs().size() != inputs.size()){
            while(getInputs().size()>inputs.size()){
                pop_backInput();
            }

            int diff =inputs.size()-getInputs().size();
            auto veri = [](const json& val){
                if(val.find("value")==val.end())
                    return false;
                return true;
            };
            while(diff > 0){
                int index=inputs.size()-diff;
                addInput(inputs[index]["type"],inputs[index]["value"], veri);
                diff =inputs.size()-getInputs().size();
            }
        }

        for(size_t i=0; i < inputs.size(); i++){
            getInput(i)->setType(inputs[i]["type"].get<std::string>());
            getInput(i)->setAppendix(i);
            getInput(i)->setDefaultValue()=inputs[i]["value"];
        }

        res = cli.Get("/outputs",
                           [&](const char *data, size_t data_length) {
                               body.append(data, data_length);
                               return true;
                           });

        //assert(res->body.empty());

        json outputs = json::parse(body);

        if(getOutputs().size() != outputs.size()){
            while(getOutputs().size()>outputs.size()){
                pop_backOutput();
            }

            int diff =outputs.size()-getOutputs().size();
            auto veri = [](const json& val){
                if(val.find("value")==val.end())
                    return false;
                return true;
            };
            while(diff > 0){
                int index=outputs.size()-diff;
                addInput(outputs[index]["type"],outputs[index]["value"], veri);
                diff =outputs.size()-getOutputs().size();
            }
        }

        for(size_t i=0; i < outputs.size(); i++){
            getOutput(i)->setType(outputs[i]["type"].get<std::string>());
            getOutput(i)->setAppendix(i);
            getOutput(i)->getValueInternal() = outputs[i]["value"];
        }
    }

    ModuleHTTP::ModuleHTTP(std::string fname, std::string id, int port):
        _fname(fname),
        _id(id),
        _port(port)
    {
        updateLayout();
    }

    bool ModuleHTTP::update() {
        updateLayout();
        /*Client cli(_id, _port);
        std::string outputs;
        auto res = cli.Get("/update",
                      [&](const char *data, size_t data_length) {
                          outputs.append(data, data_length);
                          return true;
                      });
                      */
    }
}